/****************************************************************************
 ****************************************************************************
 *
 * ec64core.h
 *
 ****************************************************************************
 ****************************************************************************/





#ifndef EC64CORE_H
#define EC64CORE_H

#include "ec64types.h"
#include "io/audio.h"
#include "io/status.h"
#include "io/video.h"
#include "core/core.h"
#include "core/cpu65xx.h"
#include "core/disc.h"

#ifdef EC64CORE_FUTURE_PLANS
extern const b				*ec64core_get_version(void);

extern sd				ec64core_initialize(void);
extern sd				ec64core_restore(void);
extern sd				ec64core_reset_hard(void);
extern sd				ec64core_reset_soft(void);
extern sd				ec64core_emulate_frame(void);
							rom_selector, pointer to data
extern sd				ec64core_set_rom(const d, const b *);
extern sd				ec64core_get_rom(const d, b *);
							ram_selector, address, pointer to data, size
extern sd				ec64core_set_ram(const d, const d, const b *, const d);
							ram_selector, address, pointer to data, size
extern sd				ec64core_get_ram(const d, const d, b *, const d);
extern sd				ec64core_set_keyboard(const b *);
extern sd				ec64core_set_joystick1(const d);
extern sd				ec64core_set_joystick2(const d);
extern sd				ec64core_set_disc_image(const b *);
extern sd				ec64core_get_disc_image(b *);

extern sd				ec64core_set_video_options(const tvideo *);
extern sd				ec64core_set_audio_options(const taudio *);
extern sd				ec64core_set_log_options(const b *, const d);

extern sd				ec64core_bp_entries(const d, const d, d *);
extern sd				ec64core_bp_get(const d, const d, void *);
extern sd				ec64core_bp_add(const d, const d, void *);
extern sd				ec64core_bp_delete(const d, const d, const d);

extern sd				ec64core_get_information(tcoreinfo *);
extern sd				ec64core_get_status(tcorestat *);
extern sd				ec64core_debug(const d, const d, void *);
#endif /* EC64CORE_FUTURE_PLANS */

extern const b				*ec64core_get_version(void);
extern void				ec64core_initialize(void);
extern void				ec64core_reset_hard(void);
extern void				ec64core_reset_soft(void);
extern sd				ec64core_emulate_pal_frame(void);
extern void				ec64core_c64_set_video_options(const tvideo *);
extern void				ec64core_c64_set_audio_options(const taudio *);
extern void				ec64core_c64_set_keyboard(const b *);
extern void				ec64core_c64_set_joystick1(const d);
extern void				ec64core_c64_set_joystick2(const d);
extern void				ec64core_c64_set_basic_rom(const b *);
extern void				ec64core_c64_set_character_rom(const b *);
extern void				ec64core_c64_set_kernel_rom(const b *);
extern const tc64stat			*ec64core_c64_get_status(void);
extern const b				*ec64core_c1541_get_disc_image(void);
extern void				ec64core_c1541_set_disc_image(const b *);
extern void				ec64core_c1541_set_kernel_rom(const b *);
extern const tc1541stat			*ec64core_c1541_get_status(void);

extern sd				ec64core_bp_entries(const d, const d, d *);
extern sd				ec64core_bp_get(const d, const d, void *);
extern sd				ec64core_bp_add(const d, const d, void *);
extern sd				ec64core_bp_delete(const d, const d, const d);

extern sd				ec64core_get_information(tcoreinfo *);
extern sd				ec64core_set_log_options(b *, d *, const d);



#endif
/********************************************* karsten.scheibler@bigfoot.de */

